; _______________________________________________________________________________________
;|                                                                                       |
;| ..:: Fresh IDE ::..  template project.                                                |
;|_______________________________________________________________________________________|
;
;  Description: FreshLib portable console application.
;
;  Target OS: Any, supported by FreshLib
;
;  Dependencies: FreshLib
;
;  Notes:
;_________________________________________________________________________________________

include "%lib%/freshlib.inc"

@BinaryType console, compact

include "%lib%/freshlib.asm"


start:
        InitializeAll

; place your code here.

        stdcall AddUniqueToList, "This is string 1"     ; returns CF=0
        stdcall AddUniqueToList, "This is string 2"     ; returns CF=0
        stdcall AddUniqueToList, "This is string 3"     ; returns CF=0
        stdcall AddUniqueToList, "This is string 4"     ; returns CF=0

        stdcall AddUniqueToList, "This is string 4"     ; returns CF=1 and the string will not be added to the list.

        FinalizeAll
        stdcall TerminateAll, 0


uglobal
  hash_table rd 65536
endg


; returns 16 bit hash in EAX!

proc HashFNV1b, .pString
begin
        push    esi

        mov     esi, [.pString]
        mov     eax, $811C9DC5                  ; 2166136261              ; FNV offset basis

.hashloop:
        cmp     byte [esi], 0
        je      .exit

        xor     al, byte [esi]
        inc     esi

        imul    eax, $01000193                  ;   16777619              ; FNV prime
        jmp     .hashloop

.exit:

; folding to 16 bit.

        mov     esi, eax
        shr     esi, 16
        xor     eax, esi
        movzx   eax, ax

        pop     esi
        return
endp



; Returns:
;
;   CF=0 - the string has been added to the list.
;   CF=1 - the string is already in the list or the list is full.


proc AddUniqueToList, .pString
begin
        pushad

        stdcall HashFNV1b, [.pString]
        mov     edx, eax                ; in order

.put_loop:
        mov     esi, [.pString]
        mov     edi, [hash_table+4*eax]
        test    edi, edi
        jnz     .compare

; Empty slot has been found

        mov     [hash_table+4*eax], esi
        clc
        popad
        return

; Collision?

.compare:
        cmpsb
        jne     .yes_collision

        cmp     byte [esi-1], 0
        jne     .compare

; the string is already in the list.

        stc
        popad
        return

.yes_collision:         ; closed hashing
        inc     ax
        cmp     eax, edx
        jne     .put_loop

; the table is full.

        stc
        popad
        return
endp
